/*****************************************************************************
*
* Copyright (C) 2003 Atmel Corporation
*
* ̧			: USI_UART.c
* ߲		: IAR EWAAVR 2.28a
* 쐬			: 18.07.2002 by JLL
* ύX			: 02-10-2003 by LTA
*
* xҰ		: avr@atmel.com
*
* x޲	: ATtiny26
*
* pLq		: AVR307 - USI̪gp锼dUART
*
* 			: USI_UART̎MƑMp֐
*				  (ėM̌oݕω荞݂gp)
*
****************************************************************************/
    
//#include <ioavr.h>	// ̧قɂ޸ނAiotiny26.h̑iotiny22.hݸٰނ邱ƂɒӂĂB
#include <iotiny26.h>
#include <inavr.h>
#include "USI_UART_config.h"


//	* USI UART` *

#define DATA_BITS	8
#define START_BIT	1
#define STOP_BIT	1
#define HALF_FRAME	5

#define USI_COUNTER_MAX_COUNT		16
#define USI_COUNTER_SEED_TRANSMIT	(USI_COUNTER_MAX_COUNT - HALF_FRAME)
#define INTERRUPT_STARTUP_DELAY		(0x11 / TIMER_PRESCALER)
#define TIMER0_SEED					(256 - ( (SYSTEM_CLOCK / BAUDRATE) / TIMER_PRESCALER ))

#if ( (( (SYSTEM_CLOCK / BAUDRATE) / TIMER_PRESCALER ) * 3/2) > (256 - INTERRUPT_STARTUP_DELAY) )
    #define INITIAL_TIMER0_SEED			( 256 - (( (SYSTEM_CLOCK / BAUDRATE) / TIMER_PRESCALER ) * 1/2) )
    #define USI_COUNTER_SEED_RECEIVE	( USI_COUNTER_MAX_COUNT - (START_BIT + DATA_BITS) )
#else
    #define INITIAL_TIMER0_SEED			( 256 - (( (SYSTEM_CLOCK / BAUDRATE) / TIMER_PRESCALER ) * 3/2) )
    #define USI_COUNTER_SEED_RECEIVE	(USI_COUNTER_MAX_COUNT - DATA_BITS)
#endif

#define UART_RX_BUFFER_MASK ( UART_RX_BUFFER_SIZE - 1 )
#if ( UART_RX_BUFFER_SIZE & UART_RX_BUFFER_MASK )
    #error Mޯ̧eʂ2ׂ̂ł܂B
#endif

#define UART_TX_BUFFER_MASK ( UART_TX_BUFFER_SIZE - 1 )
#if ( UART_TX_BUFFER_SIZE & UART_TX_BUFFER_MASK )
    #error Mޯ̧eʂ2ׂ̂ł܂B
#endif

/* ʒ` */
#define TRUE	1
#define FALSE	0

//	* ÓIϐ *

__no_init __regvar static unsigned char USI_UART_TxData @ 15;	// M޲Ăڼ޽Ɋi[邱Ƃׂ߲ɒʒm

static unsigned char          UART_RxBuf[UART_RX_BUFFER_SIZE];	// UARTMޯ̧(eʂͯ ̧قŒ`\)
static volatile unsigned char UART_RxHead;						// Mޯ̧݈ʒuwq
static volatile unsigned char UART_RxTail;						// Mޯ̧ǂݍ݈ʒuwq
static unsigned char          UART_TxBuf[UART_TX_BUFFER_SIZE];	// UARTMޯ̧(eʂͯ ̧قŒ`\)
static volatile unsigned char UART_TxHead;						// Mޯ̧݈ʒuwq
static volatile unsigned char UART_TxTail;						// Mޯ̧ǂݍ݈ʒuwq

static volatile union USI_UART_status							// e׸ނێ޲
{
    unsigned char status;
    struct
    {
        unsigned char ongoing_Transmission_From_Buffer:1;		// M׸
        unsigned char ongoing_Transmission_Of_Package:1;		// OڰёM׸
        unsigned char ongoing_Reception_Of_Package:1;			// M׸
        unsigned char reception_Buffer_Overflow:1;				// Mޯ̧׸
        unsigned char flag4:1;
        unsigned char flag5:1;
        unsigned char flag6:1;
        unsigned char flag7:1;
    };
} USI_UART_status = {0};


//	* USI_UART֐ *

// ޲ēޯď](MSBLSB)
unsigned char Bit_Reverse( unsigned char x )
{
  x = ((x >> 1) & 0x55) | ((x << 1) & 0xaa);
  x = ((x >> 2) & 0x33) | ((x << 2) & 0xcc);
  x = ((x >> 4) & 0x0f) | ((x << 4) & 0xf0);
  return x;
}

// UARTMޯ̧(j)
void USI_UART_Flush_Buffers( void )
{
  UART_RxTail = 0;									// Mޯ̧ǂݍ݈ʒuwq
  UART_RxHead = 0;									// Mޯ̧݈ʒuwq
  UART_TxTail = 0;									// Mޯ̧ǂݍ݈ʒuwq
  UART_TxHead = 0;									// Mޯ̧݈ʒuwq
}

// UARTMpUSI
void USI_UART_Initialize_Transmitter( void )
{
  __disable_interrupt();							// S̊荞݋֎~
  TCNT0  = 0x00;									// /0
  TCCR0  = (1<<PSR0)|(0<<CS02)|(0<<CS01)|(1<<CS00);	// T/COuؾ,OuȂŎn
  TIFR   = (1<<TOV0);								// /0ꊄ荞ݗv׸މ(0)
  TIMSK |= (1<<TOIE0);								// /0ꊄ荞݋

  USICR  = (0<<USISIE)|(1<<USIOIE)|					// USIvꊄ荞݋
		   (0<<USIWM1)|(1<<USIWM0)|					// 3I
		   (0<<USICS1)|(1<<USICS0)|(0<<USICLK)|		// USIۯƂT/C0I
		   (0<<USITC);

  USIDR  = 0xFF;									// (H)lݒ(DO݋OMSB=1ۏ؂ĂB)
  USISR  = 0xF0 |									// USIS׸މ(0)
		   0x0F;									// USIۯŊ荞ݐɐݒ(őݒ)
  DDRB  |= (1<<PB1);								// DOݏo͐ݒ(USIDRMSBDOɏo)

  USI_UART_status.ongoing_Transmission_From_Buffer = TRUE;	// M׸ސݒ

  __enable_interrupt();								// S̊荞݋
}

// UARTMpUSI
// ̊֐USIް݂ݕω荞݂邾ȂƂɒӂĂB
// USIݕω荞ݓްMpɌ`Ԑݒ肳܂B
void USI_UART_Initialize_Receiver( void )
{
  PORTB |=   (1<<PB3)|(1<<PB2)|(1<<PB1)|(1<<PB0);	// DO,DIƎcPB3`0ٱߋ
  DDRB  &= ~((1<<PB3)|(1<<PB2)|(1<<PB1)|(1<<PB0));	// DO,DIƎcPB3`0͐ݒ
  // DO,DIȊODIݕω荞݂gp邽߂̏ułB
  // ATtiny26PB3`0Z߂ݕω荞݂̍\Ȃ̂ŁA݂Œ艻Kv܂B
  // ݂ʂɐł޲ł͕Kv(DI,DO)u邾łB
  USICR  =  0;										// USI֎~
  GIFR   =  (1<<PCIF);								// ݕω荞ݗv׸މ(0)
  GIMSK |=  (1<<PCIE0);								// PB3`0ݕω荞݋
}

// ޯď]ް𑗐Mޯ̧Ɋi[܂B
// ɑMłȂ΁AMٰ݂܂B
void USI_UART_Transmit_Byte( unsigned char data )
{
  unsigned char tmphead;

  tmphead = ( UART_TxHead + 1 ) & UART_TX_BUFFER_MASK;		// Mޯ̧݈ʒu擾
  while ( tmphead == UART_TxTail );							// ޯ̧󂫑ҋ@
  UART_TxBuf[tmphead] = Bit_Reverse(data);					// ޯď]ްޯ̧֊i[
  UART_TxHead = tmphead;									// Mޯ̧݈ʒuwqXV

  if ( !USI_UART_status.ongoing_Transmission_From_Buffer )	// MłȂ΁A
  {
	while ( USI_UART_status.ongoing_Reception_Of_Package );	// MIҋ@
	USI_UART_Initialize_Transmitter();						// UARTMpUSI
  }
}

// Mޯ̧޲Ď擾(ޯ̧Ȃҋ@)
unsigned char USI_UART_Receive_Byte( void )
{
  unsigned char tmptail;

  while ( UART_RxHead == UART_RxTail );						// Mޯ̧ްݑҋ@
  tmptail = ( UART_RxTail + 1 ) & UART_RX_BUFFER_MASK;		// Mޯ̧ǂݍ݈ʒu擾
  UART_RxTail = tmptail;									// Mޯ̧ǂݍ݈ʒuwqXV
  return Bit_Reverse(UART_RxBuf[tmptail]);					// Mޯ̧ޯď]޲ĂƋɕA
}

// Mޯ̧ްL
unsigned char USI_UART_Data_In_Receive_Buffer( void )
{
  return ( UART_RxHead != UART_RxTail );					// Mޯ̧ȂAUŕA
}

//	* 荞ݏٰ *

// ݕω荞ݏٰ(USIMoݕω荞݂gp܂B)
// USIUARTM̎悷悤Ɍ`Ԑݒ肳܂B
#pragma vector=IO_PINS_vect
__interrupt void IO_Pin_Change_ISR(void)
{
  if (!( PINB & (1<<PB0) ))									// DI=LowȂA
  {															// (̊荞݂JnޯĂɂċNꂽƌȂ)
	TCNT0  = INTERRUPT_STARTUP_DELAY + INITIAL_TIMER0_SEED;	// (荞݉x܂)ްڰđΉvlݒ
	TCCR0  = (1<<PSR0)|(0<<CS02)|(0<<CS01)|(1<<CS00);		// T/C0Ouؾ,OuȂŎn
	TIFR   = (1<<TOV0);										// T/C0ꊄ荞ݗv׸މ(0)
	TIMSK |= (1<<TOIE0);									// T/C0ꊄ荞݋

	USICR  = (0<<USISIE)|(1<<USIOIE)|						// USIvꊄ荞݋
			 (0<<USIWM1)|(1<<USIWM0)|						// 3I
			 (0<<USICS1)|(1<<USICS0)|(0<<USICLK)|			// USIۯƂT/C0I
			 (0<<USITC);

	USISR  = 0xF0 |											// USIS׸މ(0)
			 USI_COUNTER_SEED_RECEIVE;						// Mpvlݒ
															// (USIΉ݂ݕω荞݂֎~邱Ƃɒ)
	GIMSK &=  ~(1<<PCIE0);									// PB3`0ݕω荞݋֎~

	USI_UART_status.ongoing_Reception_Of_Package = TRUE;	// M׸ސݒ
  }
}

// USIvꊄ荞ݏٰ(USIDRޯ̧ԂްړɎgp܂B)
// ̊荞݂͑MŎgp܂B
#pragma vector=USI_OVF_vect
__interrupt void USI_Counter_Overflow_ISR(void)
{
  unsigned char tmphead,tmptail;

  if( USI_UART_status.ongoing_Transmission_From_Buffer )		// MŁA
  {
	// If ongoing transmission, then send second half of transmit data.
	if( USI_UART_status.ongoing_Transmission_Of_Package )		// O/㔼JnŁA
	{
	  USI_UART_status.ongoing_Transmission_Of_Package = FALSE;	// OڰёM׸މ(0)

	  USISR = 0xF0 | (USI_COUNTER_SEED_TRANSMIT);				// USIS׸މ(0),Mpvlݒ
	  USIDR = (USI_UART_TxData << 3) | 0x07;					// USIDRɌ㔼ڰђlݒ
	}
	else														// M(Oڰ)JnŁA
	{
	  if ( UART_TxHead != UART_TxTail )							// Mޯ̧ްLŁA
	  {
		USI_UART_status.ongoing_Transmission_Of_Package = TRUE;	// OڰёM׸ސݒ

		tmptail = ( UART_TxTail + 1 ) & UART_TX_BUFFER_MASK;	// Mޯ̧ǂݍ݈ʒu擾
		UART_TxTail = tmptail;									// Mޯ̧ǂݍ݈ʒuwqXV
		USI_UART_TxData = UART_TxBuf[tmptail];					// M޲Ēl擾
		// Mlޯď]Ȃ΂Ȃ܂񂪁A荞ݓ̏xD悷邽߁A
		// ͑Mޯ̧ւ̊i[ɍsĂ܂B
		USISR  = 0xF0 | (USI_COUNTER_SEED_TRANSMIT);			// USIS׸މ(0),Mpvlݒ
		USIDR  = (USI_UART_TxData >> 2) | 0x80;					// Oڰ(Highl,Jnޯ,ʑ6ޯ)USIDRɐݒ
	  }
	  // Else enter receive mode.
	  else														// Mޯ̧ŁA
	  {
		USI_UART_status.ongoing_Transmission_From_Buffer = FALSE;	// M׸މ(0)

		TCCR0  = (0<<CS02)|(0<<CS01)|(0<<CS00);					// /0~
		PORTB |=   (1<<PB3)|(1<<PB2)|(1<<PB1)|(1<<PB0);			// DO,DIƎcPB3`0͐ݒ
		DDRB  &= ~((1<<PB3)|(1<<PB2)|(1<<PB1)|(1<<PB0));		// DO,DIƎcPB3`0͐ݒ
		USICR  =  0;											// USI֎~
		GIFR   =  (1<<PCIF);									// ݕω荞ݗv׸މ(0)
		GIMSK |=  (1<<PCIE0);									// PB3`0ݕω荞݋
	  }
	}
  }
  else															// MȊO(M(ۂɂ͎M))ŁA
  {
	USI_UART_status.ongoing_Reception_Of_Package = FALSE;		// M׸ނ(0)

	tmphead	 = ( UART_RxHead + 1 ) & UART_RX_BUFFER_MASK;		// Mޯ̧݈ʒu擾
	if ( tmphead == UART_RxTail )								// Mޯ̧tŁA
	{
	  USI_UART_status.reception_Buffer_Overflow = TRUE;			// Mޯ̧׸ސݒ(1)
	}
	else														// Mޯ̧󂫗LŁA
	{
	  UART_RxHead = tmphead;									// Mޯ̧݈ʒuwqXV
	  UART_RxBuf[tmphead] = USIDR;								// MްMޯ̧Ɋi[
	  // Mlޯď]Ȃ΂Ȃ܂񂪁A荞ݓ̏xD悷邽߁A
	  // ͎Mޯ̧̎擾ɍsĂ܂B
	}

	TCCR0  = (0<<CS02)|(0<<CS01)|(0<<CS00);						// /0~
	PORTB |=   (1<<PB3)|(1<<PB2)|(1<<PB1)|(1<<PB0);				// DO,DIƎcPB3`0͐ݒ
	DDRB  &= ~((1<<PB3)|(1<<PB2)|(1<<PB1)|(1<<PB0));			// DO,DIƎcPB3`0͐ݒ
	USICR  =  0;												// USI֎~
	GIFR   =  (1<<PCIF);										// ݕω荞ݗv׸މ(0)
	GIMSK |=  (1<<PCIE0);										// PB3`0ݕω荞݋
  }
}

// /0ꊄ荞ݏٰ(USI݂ɉM̍̎Əo͂̋NۯɎgp)
#pragma vector=TIMER0_OVF0_vect
__interrupt void Timer0_OVF_ISR(void)
{
  TCNT0 += TIMER0_SEED;		// vlĐݒ(ݒl+ޯĊԊuvl)
  // ݒlZ͊荞ݔ(TCNT0=0)猻݂܂ł̌oߎԕ␳
}

